" Let vim-gitgutter do its thing on large files
let g:gitgutter_max_signs=1000
let g:gitgutter_map_keys = 0
let g:gitgutter_highlight_linenrs = 1
let g:gitgutter_preview_win_floating = 1
let g:gitgutter_use_location_list = 0
let g:gitgutter_sign_added = '+a'
let g:gitgutter_sign_modified = '+m'
let g:gitgutter_sign_removed = '-r'
let g:gitgutter_sign_removed_first_line = '^^'
let g:gitgutter_sign_modified_removed = 'mr'

" Automatically detect style file and apply style to formatting
let g:clang_format#detect_style_file = 1
" For workspace
let g:workspace_session_directory = $HOME . '/.vim/session/'
let g:workspace_undodir = $HOME . '/.vim/undodir'
let g:workspace_autosave = 0
let g:workspace_autosave_ignore = ['gitcommit', 'qf', 'tagbar']
let g:workspace_session_disable_on_args = 1
" Toggle quickfix/location list
let g:toggle_list_no_mappings = 1

let g:mapleader = "\<Space>"
let g:maplocalleader = ','
let g:which_key_use_floating_win = 1

" Rainbow Parentheses
let g:rainbow_active = 1

" FZF
let $FZF_DEFAULT_OPTS='--layout=reverse'

" Incremental search
let g:incsearch#auto_nohlsearch = 1

" C/CPP
let g:cpp_class_scope_highlight = 1
let g:cpp_member_variable_highlight = 1
let g:cpp_class_decl_highlight = 1
let g:cpp_posix_standard = 1
let g:cpp_experimental_template_highlight = 1
let g:cpp_concepts_highlight = 1

" Sneak
let g:sneak#label = 1
let g:sneak#s_next = 1
let g:sneak#use_ic_scs = 0

" Neovim LSP Diagnostics
let g:diagnostic_enable_virtual_text = 0
let g:diagnostic_show_sign = 1
let g:diagnostic_auto_popup_while_jump = 1
let g:diagnostic_insert_delay = 1

" For nvim-completion
let g:completion_enable_auto_popup = 1
let g:completion_auto_change_source = 1
let g:completion_chain_complete_list = {
  \ 'c': [
  \    {'mode': 'keyn'},
  \    {'mode': 'tags'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'}
  \],
  \ 'haskell': [
  \    {'complete_items': ['lsp']},
  \    {'mode': 'keyn'},
  \    {'mode': 'tags'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'},
  \],
  \ 'rust': [
  \    {'complete_items': ['lsp']},
  \    {'mode': 'keyn'}
  \],
  \ 'purescript': [
  \    {'complete_items': ['lsp']},
  \    {'mode': 'keyn'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'}
  \],
  \ 'default': [
  \    {'mode': 'keyn'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'},
  \],
  \}

lua require 'lsp'
